%clear
m1=1;
m2=1;
e1=1;
e2=9;
n1=sqrt(m1/e1);
n2=sqrt(m2/e2);
thtaid=[0:90];
thtai=thtaid/180*pi;
thtar=thtai;
thtat=acos(cos(thtai).*sqrt(m1*e1/m2/e2));
ii=1;
for i=1:91
   if imag(thtat(i))~=0
      ii=ii+1;
   end
end
whitebg('white')
figure(1)
plot(thtaid,thtat/pi*180,'k')
grid
xlabel('Incident Angle (Degree)')
ylabel('Transmit Angle (Degree)')
R1=ones(91,1);
R2=ones(91,1);
T1=zeros(91,1);
T2=zeros(91,1);
R1(ii:91)=((-n1.*sin(thtai(ii:91))+n2.*sin(thtat(ii:91)))./(n1.*sin(thtai(ii:91))+n2.*sin(thtat(ii:91)))).^2;
R2(ii:91)=((n2.*sin(thtai(ii:91))-n1.*sin(thtat(ii:91)))./(n2.*sin(thtai(ii:91))+n1.*sin(thtat(ii:91)))).^2;
T1(ii:91)=(4*n1*n2.*sin(thtai(ii:91)).*sin(thtat(ii:91)))./(n1.*sin(thtai(ii:91))+n2.*sin(thtat(ii:91))).^2;
T2(ii:91)=(4*n1*n2.*sin(thtai(ii:91)).*sin(thtat(ii:91)))./(n2.*sin(thtai(ii:91))+n1.*sin(thtat(ii:91))).^2;
whitebg('white')
figure(2)
plot(thtaid,R1,'k',thtaid,T1,'k');
grid
xlabel('Angle (Degree)');
ylabel('Coefficient');
gtext('Parallel Reflection Coefficient')
gtext('Parallel Transmit Coefficient')
whitebg('white')
figure(3)
plot(thtaid,R2,'k',thtaid,T2,'k');
grid
xlabel('Angle (Degree)');
ylabel('Coefficient');
gtext('Perpendicular Reflection Coefficient')
gtext('Perpendicular Transmit Coefficient')