load f.dat
load H1.mat
load H2.mat
logh1=20*log10(abs(H1(1:1025)));
logh2=20*log10(abs(H2(1:1025)));
SNR1=logh1+140-72;
SNR2=logh2+140-72;
figure(4)
plot(f,SNR1,f,SNR2)
grid
xlabel('Frequency (Hz)')
ylabel('SNR (dB)')
gtext('Loop #6')
gtext('Loop #8')
capci1=sum(log2(1+10.^(SNR1(204:512)/10)))*20e6/1025
capci2=sum(log2(1+10.^(SNR2(204:512)/10)))*20e6/1025